Skip to content

PersistentVolume List.

GET
/api/data/namespaces/system/site/{site}/api/v1/persistentvolumes
curl --request GET \
--url https://example-corp.console.ves.volterra.io/api/v1/api/production/us-east-1/namespaces/default/api/data/namespaces/system/site/example/api/v1/persistentvolumes \
--header 'Authorization: <Authorization>'

API to GET list of Persistent Volumes in a site.

Examples of this operation.

site
required
string

Site Site name.

A successful response.

Media typeapplication/json

PersistentVolumeList is a list of PersistentVolume items.

object
items
List of persistent volumes. More info: https://kubernetes.io/docs/concepts/storage/persistent-volumes

Items in a collection or array

Array<object>
PersistentVolume (PV) is a storage resource provisioned by an administrator. It is analogous to a node. More info: https://kubernetes.io/docs/concepts/storage/persistent-volumes
object
metadata
object
annotations
Annotations is an unstructured key value map stored with a resource that may be set by external tools to store and retrieve arbitrary metadata. They are not queryable and should be preserved when modifying objects. More info: http://kubernetes.io/docs/user-guide/annotations +optional

Additional metadata and notes

object
clusterName
The name of the cluster which the object belongs to. This is used to distinguish resources with same name and namespace in different clusters. This field is not set anywhere right now and apiserver is going to ignore it if set in create or update request. +optional

Cluster or grouping configuration

string
<= 1024 characters
creationTimestamp
object
nanos

Non-negative fractions of a second at nanosecond resolution. Negative second values with fractions must still have non-negative nanos values that count forward in time. Must be from 0 to 999,999,999 inclusive. This field may be limited in precision depending on context.

integer format: int32
seconds

Represents seconds of UTC time since Unix epoch 1970-01-01T00:00:00Z. Must be from 0001-01-01T00:00:00Z to 9999-12-31T23:59:59Z inclusive.

string format: int64
<= 1024 characters
deletionGracePeriodSeconds
Number of seconds allowed for this object to gracefully terminate before it will be removed from the system. Only set when deletionTimestamp is also set. May only be shortened. Read-only. +optional

Security-related configuration

string format: int64
<= 1024 characters
deletionTimestamp
object
nanos

Non-negative fractions of a second at nanosecond resolution. Negative second values with fractions must still have non-negative nanos values that count forward in time. Must be from 0 to 999,999,999 inclusive. This field may be limited in precision depending on context.

integer format: int32
seconds

Represents seconds of UTC time since Unix epoch 1970-01-01T00:00:00Z. Must be from 0001-01-01T00:00:00Z to 9999-12-31T23:59:59Z inclusive.

string format: int64
<= 1024 characters
finalizers
Must be empty before the object is deleted from the registry. Each entry is an identifier for the responsible component that will remove the entry from the list. If the deletionTimestamp of the object is non-nil, entries in this list can only be removed. Finalizers may be processed and removed in any order. Order is NOT enforced because it introduces significant risk of stuck finalizers. finalizers is a shared field, any actor with permission can reorder it. If the finalizer list is processed in order, then this can lead to a situation in which the component responsible for the first finalizer in the list is waiting for a signal (field value, external system, or other) produced by a component responsible for a finalizer later in the list, resulting in a deadlock. Without enforced ordering finalizers are free to order amongst themselves and are not vulnerable to ordering changes in the list. +optional +patchStrategy=merge

Configuration parameter for finalizers

Array<string>
generateName

GenerateName is an optional prefix, used by the server, to generate a unique name ONLY IF the Name field has not been provided. If this field is used, the name returned to the client will be different than the name passed. This value will also be combined with a unique suffix. The provided value has the same validation rules as the Name field, and may be truncated by the length of the suffix required to make the value unique on the server.

If this field is specified and the generated name exists, the server will NOT return a 409 - instead, it will either return 201 Created or 500 with Reason ServerTimeout indicating a unique name could not be found in the time allotted, and the client should retry (optionally after the time indicated in the Retry-After header).

Applied only if Name is not specified. More info: HTTPS://git.K8s.I/O/community/contributors/devel/sig-architecture/api-conventions.md#idempotency +optional.

string
<= 1024 characters
generation
A sequence number representing a specific generation of the desired state. Populated by the system. Read-only. +optional

Configuration parameter for generation

string format: int64
<= 1024 characters
labels
Map of string keys and values that can be used to organize and categorize (scope and select) objects. May match selectors of replication controllers and services. More info: http://kubernetes.io/docs/user-guide/labels +optional

Key-value labels for organization and selection

object
managedFields

ManagedFields maps workflow-ID and version to the set of fields that are managed by that workflow. This is mostly for internal housekeeping, and users typically shouldn’t need to set or understand this field. A workflow can be the user’s name, a controller’s name, or the name of a specific apply path like “ci-cd”. The set of fields is always in the version that the workflow used when modifying the object.

+optional.

Array<object>

ManagedFieldsEntry is a workflow-ID, a FieldSet and the group version of the resource that the fieldset applies to.

object
apiVersion

APIVersion defines the version of this resource that this field set applies to. The format is “group/version” just like the top-level APIVersion field. It is necessary to track the version of a field set because it cannot be automatically converted.

string
<= 1024 characters
fieldsType
FieldsType is the discriminator for the different fields format and version. There is currently only one possible value: "FieldsV1"

Field specification or configuration

string
<= 1024 characters
fieldsV1
object
Raw

Raw is the underlying serialization of this object.

string format: byte
<= 1024 characters
manager

Manager is an identifier of the workflow managing these fields.

string
<= 1024 characters
operation

Operation is the type of operation which lead to this ManagedFieldsEntry being created. The only valid values for this field are ‘Apply’ and ‘Update’.

string
<= 1024 characters
time
object
nanos

Non-negative fractions of a second at nanosecond resolution. Negative second values with fractions must still have non-negative nanos values that count forward in time. Must be from 0 to 999,999,999 inclusive. This field may be limited in precision depending on context.

integer format: int32
seconds

Represents seconds of UTC time since Unix epoch 1970-01-01T00:00:00Z. Must be from 0001-01-01T00:00:00Z to 9999-12-31T23:59:59Z inclusive.

string format: int64
<= 1024 characters
name
Name must be unique within a namespace. Is required when creating resources, although some resources may allow a client to request the generation of an appropriate name automatically. Name is primarily intended for creation idempotence and configuration definition. Cannot be updated. More info: http://kubernetes.io/docs/user-guide/identifiers#names +optional

Human-readable name for the resource

string
>= 6 characters <= 1024 characters
namespace

Namespace defines the space within each name must be unique. An empty namespace is equivalent to the “default” namespace, but “default” is the canonical representation. Not all objects are required to be scoped to a namespace - the value of this field for those objects will be empty.

Must be a DNS_LABEL. Cannot be updated. More info: HTTP://Kubernetes.I/O/docs/user-guide/namespaces +optional.

string
>= 6 characters <= 1024 characters
ownerReferences
List of objects depended by this object. If ALL objects in the list have been deleted, this object will be garbage collected. If this object is managed by a controller, then an entry in this list will point to this controller, with the controller field set to true. There cannot be more than one managing controller. +optional +patchMergeKey=uid +patchStrategy=merge

Owner or responsible party

Array<object>

OwnerReference contains enough information to let you identify an owning object. An owning object must be in the same namespace as the dependent, or be cluster-scoped, so there is no namespace field.

object
apiVersion

API version of the referent.

string
<= 1024 characters
blockOwnerDeletion
If true, AND if the owner has the "foregroundDeletion" finalizer, then the owner cannot be deleted from the key-value store until this reference is removed. Defaults to false. To set this field, a user needs "delete" permission of the owner, otherwise 422 (Unprocessable Entity) will be returned. +optional

Blocking or denial configuration

boolean format: boolean
controller
If true, this reference points to the managing controller. +optional

Configuration parameter for controller

boolean format: boolean
kind
Kind of the referent. More info: https://git.k8s.io/community/contributors/devel/sig-architecture/api-conventions.md#types-kinds

Resource type or kind

string
>= 12 characters <= 1024 characters
name
Name of the referent. More info: http://kubernetes.io/docs/user-guide/identifiers#names

Human-readable name for the resource

string
>= 6 characters <= 1024 characters
uid
UID of the referent. More info: http://kubernetes.io/docs/user-guide/identifiers#uids

Unique identifier for this resource

string format: uuid
>= 36 characters <= 1024 characters
resourceVersion

An opaque value that represents the internal version of this object that can be used by clients to determine when objects have changed. May be used for optimistic concurrency, change detection, and the watch operation on a resource or set of resources. Clients must treat these values as opaque and passed unmodified back to the server. They may only be valid for a particular resource or set of resources.

Populated by the system. Read-only. Value must be treated as opaque by clients and . More info: HTTPS://git.K8s.I/O/community/contributors/devel/sig-architecture/api-conventions.md#concurrency-control-and-consistency +optional.

string
0 <= 1024 characters
selfLink

SelfLink is a URL representing this object. Populated by the system. Read-only.

DEPRECATED Kubernetes will stop propagating this field in 1.20 release and the field is planned to be removed in 1.21 release. +optional.

string
0 <= 1024 characters
uid

UID is the unique in time and space value for this object. It is typically generated by the server on successful creation of a resource and is not allowed to change on PUT operations.

Populated by the system. Read-only. More info: HTTP://Kubernetes.I/O/docs/user-guide/identifiers#uids +optional.

string format: uuid
>= 36 characters <= 1024 characters
spec
object
accessModes
AccessModes contains all ways the volume can be mounted. More info: https://kubernetes.io/docs/concepts/storage/persistent-volumes#access-modes +optional

Configuration parameter for accessModes

Array<string>
capacity
A description of the persistent volume's resources and capacity. More info: https://kubernetes.io/docs/concepts/storage/persistent-volumes#capacity +optional

Configuration parameter for capacity

object
claimRef
object
apiVersion
API version of the referent. +optional

Version number or identifier

string
<= 1024 characters
fieldPath
If referring to a piece of an object instead of an entire object, this string should contain a valid JSON/Go field access statement, such as desiredState.manifest.containers[2]. For example, if the object reference is to a container within a pod, this would take on a value like: "spec.containers{name}" (where "name" refers to the name of the container that triggered the event) or if no container name is specified "spec.containers[2]" (container with index 2 in this pod). This syntax is chosen only to have some well-defined way of referencing a part of an object. TODO: this design is not final and this field is subject to change in the future. +optional

Field specification or configuration

string
<= 1024 characters
kind
Kind of the referent. More info: https://git.k8s.io/community/contributors/devel/sig-architecture/api-conventions.md#types-kinds +optional

Resource type or kind

string
>= 12 characters <= 1024 characters
name
Name of the referent. More info: https://kubernetes.io/docs/concepts/overview/working-with-objects/names/#names +optional

Human-readable name for the resource

string
>= 6 characters <= 1024 characters
namespace
Namespace of the referent. More info: https://kubernetes.io/docs/concepts/overview/working-with-objects/namespaces/ +optional

Human-readable name for the resource

string
>= 6 characters <= 1024 characters
resourceVersion
Specific resourceVersion to which this reference is made, if any. More info: https://git.k8s.io/community/contributors/devel/sig-architecture/api-conventions.md#concurrency-control-and-consistency +optional

Version number or identifier

string
0 <= 1024 characters
uid
UID of the referent. More info: https://kubernetes.io/docs/concepts/overview/working-with-objects/names/#uids +optional

Unique identifier for this resource

string format: uuid
>= 36 characters <= 1024 characters
mountOptions
A list of mount options, e.g. ["ro", "soft"]. Not validated - mount will simply fail if one is invalid. More info: https://kubernetes.io/docs/concepts/storage/persistent-volumes/#mount-options +optional

Configuration parameter for mountOptions

Array<string>
nodeAffinity
object
required
object
nodeSelectorTerms

Required. A list of node selector terms. The terms are ORed.

Array<object>

A null or empty node selector term matches no objects. The requirements of them are ANDed. The TopologySelectorTerm type implements a subset of the NodeSelectorTerm.

object
matchExpressions
A list of node selector requirements by node's labels. +optional

Configuration parameter for matchExpressions

Array<object>

A node selector requirement is a selector that contains values, a key, and an operator that relates the key and values.

object
key

The label key that the selector applies to.

string
>= 7 characters <= 1024 characters
operator

Represents a key’s relationship to a set of values. Valid operators are In, NotIn, Exists, DoesNotExist. Gt, and Lt.

string
<= 1024 characters
values
An array of string values. If the operator is In or NotIn, the values array must be non-empty. If the operator is Exists or DoesNotExist, the values array must be empty. If the operator is Gt or Lt, the values array must have a single element, which will be interpreted as an integer. This array is replaced during a strategic merge patch. +optional

Configuration parameter for values

Array<string>
matchFields
A list of node selector requirements by node's fields. +optional

Configuration parameter for matchFields

Array<object>

A node selector requirement is a selector that contains values, a key, and an operator that relates the key and values.

object
key

The label key that the selector applies to.

string
>= 7 characters <= 1024 characters
operator

Represents a key’s relationship to a set of values. Valid operators are In, NotIn, Exists, DoesNotExist. Gt, and Lt.

string
<= 1024 characters
values
An array of string values. If the operator is In or NotIn, the values array must be non-empty. If the operator is Exists or DoesNotExist, the values array must be empty. If the operator is Gt or Lt, the values array must have a single element, which will be interpreted as an integer. This array is replaced during a strategic merge patch. +optional

Configuration parameter for values

Array<string>
persistentVolumeReclaimPolicy
What happens to a persistent volume when released from its claim. Valid options are Retain (default for manually created PersistentVolumes), Delete (default for dynamically provisioned PersistentVolumes), and Recycle (deprecated). Recycle must be supported by the volume plugin underlying this PersistentVolume. More info: https://kubernetes.io/docs/concepts/storage/persistent-volumes#reclaiming +optional

Configuration parameter for persistentVolumeReclaimPolicy

string
<= 1024 characters
persistentVolumeSource
object
awsElasticBlockStore
object
fsType
Filesystem type of the volume that you want to mount. Tip: Ensure that the filesystem type is supported by the host operating system. Examples: "ext4", "xfs", "ntfs". Implicitly inferred to be "ext4" if unspecified. More info: https://kubernetes.io/docs/concepts/storage/volumes#awselasticblockstore TODO: how do we prevent errors in the filesystem from compromising the machine +optional

Type or category classification

string
<= 1024 characters
partition
The partition in the volume that you want to mount. If omitted, the default is to mount by volume name. Examples: For volume /dev/sda1, you specify the partition as "1". Similarly, the volume partition for /dev/sda is "0" (or you can leave the property empty). +optional

Configuration parameter for partition

integer format: int32
readOnly
Specify "true" to force and set the ReadOnly property in VolumeMounts to "true". If omitted, the default is "false". More info: https://kubernetes.io/docs/concepts/storage/volumes#awselasticblockstore +optional

Configuration parameter for readOnly

boolean format: boolean
volumeID
Unique ID of the persistent disk resource in AWS (Amazon EBS volume). More info: https://kubernetes.io/docs/concepts/storage/volumes#awselasticblockstore

Unique identifier for this resource

string
<= 1024 characters
azureDisk
object
cachingMode
Host Caching mode: None, Read Only, Read Write. +optional

Configuration parameter for cachingMode

string
<= 1024 characters
diskName
The Name of the data disk in the blob storage

Human-readable name for this resource

string
<= 1024 characters
diskURI
The URI the data disk in the blob storage

Uniform Resource Identifier

string
<= 1024 characters
fsType
Filesystem type to mount. Must be a filesystem type supported by the host operating system. Ex. "ext4", "xfs", "ntfs". Implicitly inferred to be "ext4" if unspecified. +optional

Type or category classification

string
<= 1024 characters
kind
Expected values Shared: multiple blob disks per storage account Dedicated: single blob disk per storage account Managed: azure managed data disk (only in managed availability set). defaults to shared

Resource type or kind

string
>= 12 characters <= 1024 characters
readOnly
Defaults to false (read/write). ReadOnly here will force the ReadOnly setting in VolumeMounts. +optional

Configuration parameter for readOnly

boolean format: boolean
azureFile
object
readOnly
Defaults to false (read/write). ReadOnly here will force the ReadOnly setting in VolumeMounts. +optional

Configuration parameter for readOnly

boolean format: boolean
secretName
the name of secret that contains Azure Storage Account Name and Key

Human-readable name for this resource

string
<= 1024 characters
secretNamespace
the namespace of the secret that contains Azure Storage Account Name and Key default is the same as the Pod +optional

Namespace for resource isolation

string
<= 1024 characters
shareName
Share Name

Human-readable name for this resource

string
<= 1024 characters
cephfs
object
monitors
Required: Monitors is a collection of Ceph monitors More info: https://examples.k8s.io/volumes/cephfs/README.md#how-to-use-it

Configuration parameter for monitors

Array<string>
path
Optional: Used as the mounted root, rather than the full Ceph tree, default is / +optional

URL path for the endpoint

string
<= 1024 characters
readOnly
Optional: Defaults to false (read/write). ReadOnly here will force the ReadOnly setting in VolumeMounts. More info: https://examples.k8s.io/volumes/cephfs/README.md#how-to-use-it +optional

Configuration parameter for readOnly

boolean format: boolean
secretFile
Optional: SecretFile is the path to key ring for User, default is /etc/ceph/user.secret More info: https://examples.k8s.io/volumes/cephfs/README.md#how-to-use-it +optional

Security-related configuration

string
<= 1024 characters
secretRef
object
name
Name is unique within a namespace to reference a secret resource. +optional

Human-readable name for the resource

string
>= 6 characters <= 1024 characters
namespace
Namespace defines the space within which the secret name must be unique. +optional

Human-readable name for the resource

string
>= 6 characters <= 1024 characters
user
Optional: User is the rados user name, default is admin More info: https://examples.k8s.io/volumes/cephfs/README.md#how-to-use-it +optional

Configuration parameter for user

string
<= 1024 characters
cinder
object
fsType
Filesystem type to mount. Must be a filesystem type supported by the host operating system. Examples: "ext4", "xfs", "ntfs". Implicitly inferred to be "ext4" if unspecified. More info: https://examples.k8s.io/mysql-cinder-pd/README.md +optional

Type or category classification

string
<= 1024 characters
readOnly
Optional: Defaults to false (read/write). ReadOnly here will force the ReadOnly setting in VolumeMounts. More info: https://examples.k8s.io/mysql-cinder-pd/README.md +optional

Configuration parameter for readOnly

boolean format: boolean
secretRef
object
name
Name is unique within a namespace to reference a secret resource. +optional

Human-readable name for the resource

string
>= 6 characters <= 1024 characters
namespace
Namespace defines the space within which the secret name must be unique. +optional

Human-readable name for the resource

string
>= 6 characters <= 1024 characters
volumeID
volume id used to identify the volume in cinder. More info: https://examples.k8s.io/mysql-cinder-pd/README.md

Unique identifier for this resource

string
<= 1024 characters
csi
object
controllerExpandSecretRef
object
name
Name is unique within a namespace to reference a secret resource. +optional

Human-readable name for the resource

string
>= 6 characters <= 1024 characters
namespace
Namespace defines the space within which the secret name must be unique. +optional

Human-readable name for the resource

string
>= 6 characters <= 1024 characters
controllerPublishSecretRef
object
name
Name is unique within a namespace to reference a secret resource. +optional

Human-readable name for the resource

string
>= 6 characters <= 1024 characters
namespace
Namespace defines the space within which the secret name must be unique. +optional

Human-readable name for the resource

string
>= 6 characters <= 1024 characters
driver

Driver is the name of the driver to use for this volume. Required.

string
<= 1024 characters
fsType
Filesystem type to mount. Must be a filesystem type supported by the host operating system. Ex. "ext4", "xfs", "ntfs". +optional

Type or category classification

string
<= 1024 characters
nodePublishSecretRef
object
name
Name is unique within a namespace to reference a secret resource. +optional

Human-readable name for the resource

string
>= 6 characters <= 1024 characters
namespace
Namespace defines the space within which the secret name must be unique. +optional

Human-readable name for the resource

string
>= 6 characters <= 1024 characters
nodeStageSecretRef
object
name
Name is unique within a namespace to reference a secret resource. +optional

Human-readable name for the resource

string
>= 6 characters <= 1024 characters
namespace
Namespace defines the space within which the secret name must be unique. +optional

Human-readable name for the resource

string
>= 6 characters <= 1024 characters
readOnly
Optional: The value to pass to ControllerPublishVolumeRequest. Defaults to false (read/write). +optional

Configuration parameter for readOnly

boolean format: boolean
volumeAttributes
Attributes of the volume to publish. +optional

Configuration parameter for volumeAttributes

object
volumeHandle

VolumeHandle is the unique volume name returned by the CSI volume plugin’s CreateVolume to refer to the volume on all subsequent calls. Required.

string
<= 1024 characters
fc
object
fsType
Filesystem type to mount. Must be a filesystem type supported by the host operating system. Ex. "ext4", "xfs", "ntfs". Implicitly inferred to be "ext4" if unspecified. TODO: how do we prevent errors in the filesystem from compromising the machine +optional

Type or category classification

string
<= 1024 characters
lun
Optional: FC target lun number +optional

Configuration parameter for lun

integer format: int32
readOnly
Optional: Defaults to false (read/write). ReadOnly here will force the ReadOnly setting in VolumeMounts. +optional

Configuration parameter for readOnly

boolean format: boolean
targetWWNs
Optional: FC target worldwide names (WWNs) +optional

Configuration parameter for targetWWNs

Array<string>
wwids
Optional: FC volume world wide identifiers (wwids) Either wwids or combination of targetWWNs and lun must be set, but not both simultaneously. +optional

Configuration parameter for wwids

Array<string>
flexVolume
object
driver

Driver is the name of the driver to use for this volume.

string
<= 1024 characters
fsType
Filesystem type to mount. Must be a filesystem type supported by the host operating system. Ex. "ext4", "xfs", "ntfs". The default filesystem depends on FlexVolume script. +optional

Type or category classification

string
<= 1024 characters
options
Optional: Extra command options if any. +optional

Configuration parameter for options

object
readOnly
Optional: Defaults to false (read/write). ReadOnly here will force the ReadOnly setting in VolumeMounts. +optional

Configuration parameter for readOnly

boolean format: boolean
secretRef
object
name
Name is unique within a namespace to reference a secret resource. +optional

Human-readable name for the resource

string
>= 6 characters <= 1024 characters
namespace
Namespace defines the space within which the secret name must be unique. +optional

Human-readable name for the resource

string
>= 6 characters <= 1024 characters
flocker
object
datasetName
Name of the dataset stored as metadata -> name on the dataset for Flocker should be considered as deprecated +optional

Data or content configuration

string
<= 1024 characters
datasetUUID
UUID of the dataset. This is unique identifier of a Flocker dataset +optional

Data or content configuration

string
<= 1024 characters
gcePersistentDisk
object
fsType
Filesystem type of the volume that you want to mount. Tip: Ensure that the filesystem type is supported by the host operating system. Examples: "ext4", "xfs", "ntfs". Implicitly inferred to be "ext4" if unspecified. More info: https://kubernetes.io/docs/concepts/storage/volumes#gcepersistentdisk TODO: how do we prevent errors in the filesystem from compromising the machine +optional

Type or category classification

string
<= 1024 characters
partition
The partition in the volume that you want to mount. If omitted, the default is to mount by volume name. Examples: For volume /dev/sda1, you specify the partition as "1". Similarly, the volume partition for /dev/sda is "0" (or you can leave the property empty). More info: https://kubernetes.io/docs/concepts/storage/volumes#gcepersistentdisk +optional

Configuration parameter for partition

integer format: int32
pdName
Unique name of the PD resource in GCE. Used to identify the disk in GCE. More info: https://kubernetes.io/docs/concepts/storage/volumes#gcepersistentdisk

Human-readable name for this resource

string
<= 1024 characters
readOnly
ReadOnly here will force the ReadOnly setting in VolumeMounts. Defaults to false. More info: https://kubernetes.io/docs/concepts/storage/volumes#gcepersistentdisk +optional

Configuration parameter for readOnly

boolean format: boolean
glusterfs
object
endpoints
EndpointsName is the endpoint name that details Glusterfs topology. More info: https://examples.k8s.io/volumes/glusterfs/README.md#create-a-pod

Endpoint or connection point

string
<= 1024 characters
endpointsNamespace
EndpointsNamespace is the namespace that contains Glusterfs endpoint. If this field is empty, the EndpointNamespace defaults to the same namespace as the bound PVC. More info: https://examples.k8s.io/volumes/glusterfs/README.md#create-a-pod +optional

Endpoint or connection point

string
<= 1024 characters
path
Path is the Glusterfs volume path. More info: https://examples.k8s.io/volumes/glusterfs/README.md#create-a-pod

URL path for the endpoint

string
<= 1024 characters
readOnly
ReadOnly here will force the Glusterfs volume to be mounted with read-only permissions. Defaults to false. More info: https://examples.k8s.io/volumes/glusterfs/README.md#create-a-pod +optional

Configuration parameter for readOnly

boolean format: boolean
hostPath
object
path
Path of the directory on the host. If the path is a symlink, it will follow the link to the real path. More info: https://kubernetes.io/docs/concepts/storage/volumes#hostpath

URL path for the endpoint

string
<= 1024 characters
type
Type for HostPath Volume Defaults to "" More info: https://kubernetes.io/docs/concepts/storage/volumes#hostpath +optional

Type or category classification

string
<= 1024 characters
iscsi
object
chapAuthDiscovery
whether support iSCSI Discovery CHAP authentication +optional

Configuration parameter for chapAuthDiscovery

boolean format: boolean
chapAuthSession
whether support iSCSI Session CHAP authentication +optional

Configuration parameter for chapAuthSession

boolean format: boolean
fsType
Filesystem type of the volume that you want to mount. Tip: Ensure that the filesystem type is supported by the host operating system. Examples: "ext4", "xfs", "ntfs". Implicitly inferred to be "ext4" if unspecified. More info: https://kubernetes.io/docs/concepts/storage/volumes#iscsi TODO: how do we prevent errors in the filesystem from compromising the machine +optional

Type or category classification

string
<= 1024 characters
initiatorName
Custom iSCSI Initiator Name. If initiatorName is specified with iscsiInterface simultaneously, new iSCSI interface <target portal>:<volume name> will be created for the connection. +optional

Human-readable name for this resource

string
<= 1024 characters
iqn

Target iSCSI Qualified Name.

string
<= 1024 characters
iscsiInterface
iSCSI Interface Name that uses an iSCSI transport. Defaults to 'default' (tcp). +optional

Configuration parameter for iscsiInterface

string
<= 1024 characters
lun

ISCSI Target Lun number.

integer format: int32
portals
iSCSI Target Portal List. The Portal is either an IP or ip_addr:port if the port is other than default (typically TCP ports 860 and 3260). +optional

Network port number

Array<string>
readOnly
ReadOnly here will force the ReadOnly setting in VolumeMounts. Defaults to false. +optional

Configuration parameter for readOnly

boolean format: boolean
secretRef
object
name
Name is unique within a namespace to reference a secret resource. +optional

Human-readable name for the resource

string
>= 6 characters <= 1024 characters
namespace
Namespace defines the space within which the secret name must be unique. +optional

Human-readable name for the resource

string
>= 6 characters <= 1024 characters
targetPortal

ISCSI Target Portal. The Portal is either an IP or ip_addr:port if the port is other than default (typically TCP ports 860 and 3260).

string
<= 1024 characters
local
object
fsType
Filesystem type to mount. It applies only when the Path is a block device. Must be a filesystem type supported by the host operating system. Ex. "ext4", "xfs", "ntfs". The default value is to auto-select a fileystem if unspecified. +optional

Type or category classification

string
<= 1024 characters
path

The full path to the volume on the node. It can be either a directory or block device (disk, partition, …).

string
<= 1024 characters
nfs
object
path
Path that is exported by the NFS server. More info: https://kubernetes.io/docs/concepts/storage/volumes#nfs

URL path for the endpoint

string
<= 1024 characters
readOnly
ReadOnly here will force the NFS export to be mounted with read-only permissions. Defaults to false. More info: https://kubernetes.io/docs/concepts/storage/volumes#nfs +optional

Configuration parameter for readOnly

boolean format: boolean
server
Server is the hostname or IP address of the NFS server. More info: https://kubernetes.io/docs/concepts/storage/volumes#nfs

Configuration parameter for server

string
<= 1024 characters
photonPersistentDisk
object
fsType

Filesystem type to mount. Must be a filesystem type supported by the host operating system. Ex. “ext4”, “xfs”, “ntfs”. Implicitly inferred to be “ext4” if unspecified.

string
<= 1024 characters
pdID
ID that identifies Photon Controller persistent disk

Unique identifier for this resource

string
<= 1024 characters
portworxVolume
object
fsType

FSType represents the filesystem type to mount Must be a filesystem type supported by the host operating system. Ex. “ext4”, “xfs”. Implicitly inferred to be “ext4” if unspecified.

string
<= 1024 characters
readOnly
Defaults to false (read/write). ReadOnly here will force the ReadOnly setting in VolumeMounts. +optional

Configuration parameter for readOnly

boolean format: boolean
volumeID
VolumeID uniquely identifies a Portworx volume

Unique identifier for this resource

string
<= 1024 characters
quobyte
object
group
Group to map volume access to Default is no group +optional

Configuration parameter for group

string
<= 1024 characters
readOnly
ReadOnly here will force the Quobyte volume to be mounted with read-only permissions. Defaults to false. +optional

Configuration parameter for readOnly

boolean format: boolean
registry
Registry represents a single or multiple Quobyte Registry services specified as a string as host:port pair (multiple entries are separated with commas) which acts as the central registry for volumes

Configuration parameter for registry

string
<= 1024 characters
tenant
Tenant owning the given Quobyte volume in the Backend Used with dynamically provisioned Quobyte volumes, value is set by the plugin +optional

Tenant identifier for multi-tenancy

string
>= 6 characters <= 1024 characters
user
User to map volume access to Defaults to serivceaccount user +optional

Configuration parameter for user

string
<= 1024 characters
volume

Volume is a string that references an already created Quobyte volume by name.

string
<= 1024 characters
rbd
object
fsType
Filesystem type of the volume that you want to mount. Tip: Ensure that the filesystem type is supported by the host operating system. Examples: "ext4", "xfs", "ntfs". Implicitly inferred to be "ext4" if unspecified. More info: https://kubernetes.io/docs/concepts/storage/volumes#rbd TODO: how do we prevent errors in the filesystem from compromising the machine +optional

Type or category classification

string
<= 1024 characters
image
The rados image name. More info: https://examples.k8s.io/volumes/rbd/README.md#how-to-use-it

Configuration parameter for image

string
<= 1024 characters
keyring
Keyring is the path to key ring for RBDUser. Default is /etc/ceph/keyring. More info: https://examples.k8s.io/volumes/rbd/README.md#how-to-use-it +optional

Configuration parameter for keyring

string
<= 1024 characters
monitors
A collection of Ceph monitors. More info: https://examples.k8s.io/volumes/rbd/README.md#how-to-use-it

Configuration parameter for monitors

Array<string>
pool
The rados pool name. Default is rbd. More info: https://examples.k8s.io/volumes/rbd/README.md#how-to-use-it +optional

Configuration parameter for pool

string
<= 1024 characters
readOnly
ReadOnly here will force the ReadOnly setting in VolumeMounts. Defaults to false. More info: https://examples.k8s.io/volumes/rbd/README.md#how-to-use-it +optional

Configuration parameter for readOnly

boolean format: boolean
secretRef
object
name
Name is unique within a namespace to reference a secret resource. +optional

Human-readable name for the resource

string
>= 6 characters <= 1024 characters
namespace
Namespace defines the space within which the secret name must be unique. +optional

Human-readable name for the resource

string
>= 6 characters <= 1024 characters
user
The rados user name. Default is admin. More info: https://examples.k8s.io/volumes/rbd/README.md#how-to-use-it +optional

Configuration parameter for user

string
<= 1024 characters
scaleIO
object
fsType
Filesystem type to mount. Must be a filesystem type supported by the host operating system. Ex. "ext4", "xfs", "ntfs". Default is "xfs" +optional

Type or category classification

string
<= 1024 characters
gateway

The host address of the ScaleIO API Gateway.

string
<= 1024 characters
protectionDomain
The name of the ScaleIO Protection Domain for the configured storage. +optional

Configuration parameter for protectionDomain

string
<= 1024 characters
readOnly
Defaults to false (read/write). ReadOnly here will force the ReadOnly setting in VolumeMounts. +optional

Configuration parameter for readOnly

boolean format: boolean
secretRef
object
name
Name is unique within a namespace to reference a secret resource. +optional

Human-readable name for the resource

string
>= 6 characters <= 1024 characters
namespace
Namespace defines the space within which the secret name must be unique. +optional

Human-readable name for the resource

string
>= 6 characters <= 1024 characters
sslEnabled
Flag to enable/disable SSL communication with Gateway, default false +optional

Enable or disable functionality flag

boolean format: boolean
storageMode
Indicates whether the storage for a volume should be ThickProvisioned or ThinProvisioned. Default is ThinProvisioned. +optional

Configuration parameter for storageMode

string
<= 1024 characters
storagePool
The ScaleIO Storage Pool associated with the protection domain. +optional

Configuration parameter for storagePool

string
<= 1024 characters
system

The name of the storage system as configured in ScaleIO.

string
<= 1024 characters
volumeName

The name of a volume already created in the ScaleIO system that is associated with this volume source.

string
<= 1024 characters
storageos
object
fsType
Filesystem type to mount. Must be a filesystem type supported by the host operating system. Ex. "ext4", "xfs", "ntfs". Implicitly inferred to be "ext4" if unspecified. +optional

Type or category classification

string
<= 1024 characters
readOnly
Defaults to false (read/write). ReadOnly here will force the ReadOnly setting in VolumeMounts. +optional

Configuration parameter for readOnly

boolean format: boolean
secretRef
object
apiVersion
API version of the referent. +optional

Version number or identifier

string
<= 1024 characters
fieldPath
If referring to a piece of an object instead of an entire object, this string should contain a valid JSON/Go field access statement, such as desiredState.manifest.containers[2]. For example, if the object reference is to a container within a pod, this would take on a value like: "spec.containers{name}" (where "name" refers to the name of the container that triggered the event) or if no container name is specified "spec.containers[2]" (container with index 2 in this pod). This syntax is chosen only to have some well-defined way of referencing a part of an object. TODO: this design is not final and this field is subject to change in the future. +optional

Field specification or configuration

string
<= 1024 characters
kind
Kind of the referent. More info: https://git.k8s.io/community/contributors/devel/sig-architecture/api-conventions.md#types-kinds +optional

Resource type or kind

string
>= 12 characters <= 1024 characters
name
Name of the referent. More info: https://kubernetes.io/docs/concepts/overview/working-with-objects/names/#names +optional

Human-readable name for the resource

string
>= 6 characters <= 1024 characters
namespace
Namespace of the referent. More info: https://kubernetes.io/docs/concepts/overview/working-with-objects/namespaces/ +optional

Human-readable name for the resource

string
>= 6 characters <= 1024 characters
resourceVersion
Specific resourceVersion to which this reference is made, if any. More info: https://git.k8s.io/community/contributors/devel/sig-architecture/api-conventions.md#concurrency-control-and-consistency +optional

Version number or identifier

string
0 <= 1024 characters
uid
UID of the referent. More info: https://kubernetes.io/docs/concepts/overview/working-with-objects/names/#uids +optional

Unique identifier for this resource

string format: uuid
>= 36 characters <= 1024 characters
volumeName

VolumeName is the human-readable name of the StorageOS volume. Volume names are only unique within a namespace.

string
<= 1024 characters
volumeNamespace
VolumeNamespace specifies the scope of the volume within StorageOS. If no namespace is specified then the Pod's namespace will be used. This allows the Kubernetes name scoping to be mirrored within StorageOS for tighter integration. Set VolumeName to any name to override the default behaviour. Set to "default" if you are not using namespaces within StorageOS. Namespaces that do not pre-exist within StorageOS will be created. +optional

Namespace for resource isolation

string
<= 1024 characters
vsphereVolume
object
fsType
Filesystem type to mount. Must be a filesystem type supported by the host operating system. Ex. "ext4", "xfs", "ntfs". Implicitly inferred to be "ext4" if unspecified. +optional

Type or category classification

string
<= 1024 characters
storagePolicyID
Storage Policy Based Management (SPBM) profile ID associated with the StoragePolicyName. +optional

Unique identifier for this resource

string
<= 1024 characters
storagePolicyName
Storage Policy Based Management (SPBM) profile name. +optional

Human-readable name for this resource

string
<= 1024 characters
volumePath
Path that identifies vSphere volume vmdk

File system or URL path

string
<= 1024 characters
storageClassName
Name of StorageClass to which this persistent volume belongs. Empty value means that this volume does not belong to any StorageClass. +optional

Human-readable name for this resource

string
<= 1024 characters
volumeMode
volumeMode defines if a volume is intended to be used with a formatted filesystem or to remain in raw block state. Value of Filesystem is implied when not included in spec. This is a beta feature. +optional

Configuration parameter for volumeMode

string
<= 1024 characters
status
object
message
A human-readable message indicating details about why the volume is in this state. +optional

Configuration parameter for message

string
<= 1024 characters
phase
Phase indicates if a volume is available, bound to a claim, or released by a claim. More info: https://kubernetes.io/docs/concepts/storage/persistent-volumes#phase +optional

Current phase in the lifecycle

string
<= 1024 characters
reason
Reason is a brief CamelCase string that describes any failure and is meant for machine parsing and tidy display in the CLI. +optional

Configuration parameter for reason

string
>= 27 characters <= 1024 characters
metadata
object
continue

Continue may be set if the user set a limit on the number of items returned, and indicates that the server has more data available. The value is opaque and may be used to issue another request to the endpoint that served this list to retrieve the next set of available objects. Continuing a consistent list may not be possible if the server configuration has changed or more than a few minutes have passed. The resourceVersion field returned when using this continue value will be identical to the value in the first response, unless you have received this token from an error message.

string
0 <= 1024 characters
remainingItemCount
remainingItemCount is the number of subsequent items in the list which are not included in this list response. If the list request contained label or field selectors, then the number of remaining items is unknown and the field will be left unset and omitted during serialization. If the list is complete (either because it is not chunking or because this is the last chunk), then there are no more remaining items and this field will be left unset and omitted during serialization. Servers older than v1.15 do not set this field. The intended use of the remainingItemCount is *estimating* the size of a collection. Clients should not rely on the remainingItemCount to be set or to be exact. +optional

Number of items or occurrences

string format: int64
<= 1024 characters
resourceVersion
String that identifies the server's internal version of this object that can be used by clients to determine when objects have changed. Value must be treated as opaque by clients and passed unmodified back to the server. Populated by the system. Read-only. More info: https://git.k8s.io/community/contributors/devel/sig-architecture/api-conventions.md#concurrency-control-and-consistency +optional

Version number or identifier

string
0 <= 1024 characters
selfLink

SelfLink is a URL representing this object. Populated by the system. Read-only.

DEPRECATED Kubernetes will stop propagating this field in 1.20 release and the field is planned to be removed in 1.21 release. +optional.

string
0 <= 1024 characters
Examplegenerated
{
"items": [
{
"metadata": {
"annotations": {},
"clusterName": "example",
"creationTimestamp": {
"nanos": 1,
"seconds": "example"
},
"deletionGracePeriodSeconds": "example",
"deletionTimestamp": {
"nanos": 1,
"seconds": "example"
},
"finalizers": [
"example"
],
"generateName": "example",
"generation": "example",
"labels": {},
"managedFields": [
{
"apiVersion": "example",
"fieldsType": "example",
"fieldsV1": {
"Raw": "example"
},
"manager": "example",
"operation": "example",
"time": {
"nanos": 1,
"seconds": "example"
}
}
],
"name": "example",
"namespace": "example",
"ownerReferences": [
{
"apiVersion": "example",
"blockOwnerDeletion": true,
"controller": true,
"kind": "example",
"name": "example",
"uid": "2489E9AD-2EE2-8E00-8EC9-32D5F69181C0"
}
],
"resourceVersion": "example",
"selfLink": "example",
"uid": "2489E9AD-2EE2-8E00-8EC9-32D5F69181C0"
},
"spec": {
"accessModes": [
"example"
],
"capacity": {},
"claimRef": {
"apiVersion": "example",
"fieldPath": "example",
"kind": "example",
"name": "example",
"namespace": "example",
"resourceVersion": "example",
"uid": "2489E9AD-2EE2-8E00-8EC9-32D5F69181C0"
},
"mountOptions": [
"example"
],
"nodeAffinity": {
"required": {
"nodeSelectorTerms": [
{
"matchExpressions": [
{
"key": "example",
"operator": "example",
"values": [
"example"
]
}
],
"matchFields": [
{
"key": "example",
"operator": "example",
"values": [
"example"
]
}
]
}
]
}
},
"persistentVolumeReclaimPolicy": "example",
"persistentVolumeSource": {
"awsElasticBlockStore": {
"fsType": "example",
"partition": 1,
"readOnly": true,
"volumeID": "example"
},
"azureDisk": {
"cachingMode": "example",
"diskName": "example",
"diskURI": "example",
"fsType": "example",
"kind": "example",
"readOnly": true
},
"azureFile": {
"readOnly": true,
"secretName": "example",
"secretNamespace": "example",
"shareName": "example"
},
"cephfs": {
"monitors": [
"example"
],
"path": "example",
"readOnly": true,
"secretFile": "example",
"secretRef": {
"name": "example",
"namespace": "example"
},
"user": "example"
},
"cinder": {
"fsType": "example",
"readOnly": true,
"secretRef": {
"name": "example",
"namespace": "example"
},
"volumeID": "example"
},
"csi": {
"controllerExpandSecretRef": {
"name": "example",
"namespace": "example"
},
"controllerPublishSecretRef": {
"name": "example",
"namespace": "example"
},
"driver": "example",
"fsType": "example",
"nodePublishSecretRef": {
"name": "example",
"namespace": "example"
},
"nodeStageSecretRef": {
"name": "example",
"namespace": "example"
},
"readOnly": true,
"volumeAttributes": {},
"volumeHandle": "example"
},
"fc": {
"fsType": "example",
"lun": 1,
"readOnly": true,
"targetWWNs": [
"example"
],
"wwids": [
"example"
]
},
"flexVolume": {
"driver": "example",
"fsType": "example",
"options": {},
"readOnly": true,
"secretRef": {
"name": "example",
"namespace": "example"
}
},
"flocker": {
"datasetName": "example",
"datasetUUID": "example"
},
"gcePersistentDisk": {
"fsType": "example",
"partition": 1,
"pdName": "example",
"readOnly": true
},
"glusterfs": {
"endpoints": "example",
"endpointsNamespace": "example",
"path": "example",
"readOnly": true
},
"hostPath": {
"path": "example",
"type": "example"
},
"iscsi": {
"chapAuthDiscovery": true,
"chapAuthSession": true,
"fsType": "example",
"initiatorName": "example",
"iqn": "example",
"iscsiInterface": "example",
"lun": 1,
"portals": [
"example"
],
"readOnly": true,
"secretRef": {
"name": "example",
"namespace": "example"
},
"targetPortal": "example"
},
"local": {
"fsType": "example",
"path": "example"
},
"nfs": {
"path": "example",
"readOnly": true,
"server": "example"
},
"photonPersistentDisk": {
"fsType": "example",
"pdID": "example"
},
"portworxVolume": {
"fsType": "example",
"readOnly": true,
"volumeID": "example"
},
"quobyte": {
"group": "example",
"readOnly": true,
"registry": "example",
"tenant": "example",
"user": "example",
"volume": "example"
},
"rbd": {
"fsType": "example",
"image": "example",
"keyring": "example",
"monitors": [
"example"
],
"pool": "example",
"readOnly": true,
"secretRef": {
"name": "example",
"namespace": "example"
},
"user": "example"
},
"scaleIO": {
"fsType": "example",
"gateway": "example",
"protectionDomain": "example",
"readOnly": true,
"secretRef": {
"name": "example",
"namespace": "example"
},
"sslEnabled": true,
"storageMode": "example",
"storagePool": "example",
"system": "example",
"volumeName": "example"
},
"storageos": {
"fsType": "example",
"readOnly": true,
"secretRef": {
"apiVersion": "example",
"fieldPath": "example",
"kind": "example",
"name": "example",
"namespace": "example",
"resourceVersion": "example",
"uid": "2489E9AD-2EE2-8E00-8EC9-32D5F69181C0"
},
"volumeName": "example",
"volumeNamespace": "example"
},
"vsphereVolume": {
"fsType": "example",
"storagePolicyID": "example",
"storagePolicyName": "example",
"volumePath": "example"
}
},
"storageClassName": "example",
"volumeMode": "example"
},
"status": {
"message": "example",
"phase": "example",
"reason": "example"
}
}
],
"metadata": {
"continue": "example",
"remainingItemCount": "example",
"resourceVersion": "example",
"selfLink": "example"
}
}

Returned when operation is not authorized.

Media typeapplication/json
string format: string
Examplegenerated
example

Returned when there is no permission to access resource.

Media typeapplication/json
string format: string
Examplegenerated
example

Returned when resource is not found.

Media typeapplication/json
string format: string
Examplegenerated
example

Returned when operation on resource is conflicting with current value.

Media typeapplication/json
string format: string
Examplegenerated
example

Returned when operation has been rejected as it is happening too frequently.

Media typeapplication/json
string format: string
Examplegenerated
example

Returned when server encountered an error in processing API.

Media typeapplication/json
string format: string
Examplegenerated
example

Returned when service is unavailable temporarily.

Media typeapplication/json
string format: string
Examplegenerated
example

Returned when server timed out processing request.

Media typeapplication/json
string format: string
Examplegenerated
example